/*
   This file is part of the Dvegas library for adaptive Monte Carlo
   integration inspired by Lepage's VEGAS algorithm.
   Copyright (C) 2000-2002, 2012 Nikolas Kauer, Martin Wiebusch

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef RANDOMNUMBERGENERATOR_H
#define RANDOMNUMBERGENERATOR_H

#include <vector>
using std::vector;

class RandomNumberGenerator
{
public:
  virtual const double uniformInZeroOne() = 0;     // excludes 0 and 1
  virtual void uniformInZeroOne(vector<double>& vectorOfRandomNumbers);
  virtual void setSeedAndLuxuryLevel(const long int seed, const int luxury) = 0;
  virtual void varySeedToGetIndependentRandomNumberStreams(const long int unique) = 0;
  virtual ~RandomNumberGenerator();
};

extern RandomNumberGenerator *const randomNumberGenerator;

#endif     /* RANDOMNUMBERGENERATOR_H */
